<?php

class modules
{
	private static $ini_obj = false;

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	public static function get_start_elem()
	{
		return self :: _get_s('start');
	}
	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	public static function get_diagram_elem()
	{
		return self :: _get_s('diagram');
	}

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	public static function get_config_elem()
	{
		return self :: _get_s('edit');
	}

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	public static function get_scripts()
	{
		return self :: _get_s('script');
	}
	
	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	private static function _get_s($n)
	{
		self :: _ini_on();
		$ret = array();

		foreach(self :: $ini_obj as $k => $v)
		{
			if(isset($v[$n]))
			{
				if(isset($v['ico']) && strpos($v['ico'], '.png') > 0)
				{					
					$v['ico'] = '_img/modules/' . $v['ico'];
				}

				$ret[$k] = $v;
			}
		}

		return $ret;
	}

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
/*
	public static function get_modules($disp = '')
	{
		self :: _ini_on();

		if($disp == 'start')
			$ns = array('gpio', 'variables', 'ports', 'rs485', 'i2c', 'rflink', 'devices', 'zigbee', 'events', 'time', 'tasks');
		else
			$ns = array('parameters', 'variables', 'gpio', 'rflink', 'rs485', 'time', 'tasks', 'events', 'i2c', 'ports', 'boiler_ot', 'devices', 'zigbee', 'script');

		$ret = array();
		foreach($ns as $v)
		{
			$ret[$v] = array(
				'name' => self :: _gam(self :: $ini_obj, array($v, 'name'), $v),
				'desc' => self :: _ga(self :: $desc_mods, $v, '---'),
				'ico' => self :: _gam(self :: $ini_obj, array($v, 'ico'), '---')
			);
		}

		return $ret	;
	}

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	public static function get_config_elem()
	{
		return self :: get_modules();
	}

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	public static function get_scripts()
	{
		self :: _ini_on();

		$ns = array('mk', 'mk2', 'devices', 'mqtt', 'ports', 'i2c', 'rs485', 'rflink', 'boiler_ot', 'zigbee', 'pings'	);

		$ret = array();
		foreach($ns as $v)
		{
			$ret[$v] = array(
				'name' => self :: _gam(self :: $ini_obj, array($v, 'name'), $v),
				'desc' => self :: _ga(self :: $desc_mods, $v, '---'),
				'ico' => self :: _gam(self :: $ini_obj, array($v, 'ico'), '---')
			);
		}

		return $ret	;
	}
*/
	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	public static function get_mod_help($m)
	{
		$f = ROOT_DIR . 'src/mod_'.$m.'_help_config.html';
		
		if(file_exists($f))
			return file_get_contents($f);
		else
			return false;
	}	

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	public static function getDescMods($n = false)
	{
		//include('src/modules_desc.php');
		self :: _ini_on();
		return $n? self :: _ga(self :: $desc_mods, $n, '') : self :: $desc_mods ;
	}

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	private static function _ini_on()
	{
		if(!self :: $ini_obj)
		{
			self :: $ini_obj = parse_ini_file(ROOT_DIR . 'src/modules.ini', true);

			include(ROOT_DIR . 'src/modules_desc.php');
			
			if(isset($DESCRIPTION_MODS))
			{
				foreach(self :: $ini_obj as $k => $v)
					self :: $ini_obj[$k]['desc'] = self :: _ga($DESCRIPTION_MODS, $k, '');
			}			
		}
	}

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	private static function _ga($o, $k, $d = false)
	{
		return is_array($o) && array_key_exists($k, $o)? $o[$k] : $d ;
	}
}


?>