<?php

class parse_str
{
	public static function get_tbl_usage($lines)
	{
		$obj = array();

		//USER       PID %CPU %MEM    VSZ   RSS TTY      STAT START   TIME COMMAND

		foreach($lines as $line)
		{
			$tds = preg_split('/\s+/', $line);
			$obj[] = $tds;
		}

		//echo '<pre style="font-family:verdana;font-size:10px;">'.print_r($obj, true).'</pre>';die;

		$tbl = array();

		foreach($obj as $v)
		{
			$_n = (isset($v[12]) && strpos($v[12], '.py') > 0)? basename($v[12]) : (isset($v[11])? $v[11] : false);
			
			if($_n && isset($v[3]))
			{
				$tbl[] = array($v[1], $_n, $v[2], $v[3], '<a href="#" onclick="kill_process_pthns('.$v[1].'); return false;">x</a>');
			}
		}

		$jss = <<< HTML
		<script>
			function kill_process_pthns(id){
				if(confirm('Zamknąć proces?'))
					page.sendQuery('index.php?a=ptcmds&b=kill_process_nr&nr=' + id, () => {endmsg('Wysłano polecenie zamknięcia');});
			}
		</script>
		HTML;		

		//echo '<pre style="font-family:verdana;font-size:10px;">'.print_r($tbl, true).'</pre>';die;

		return self :: _tbl($tbl, array('PID', 'Nazwa', 'CPU %', 'Pamięć', 'x')) . $jss;
	}

	public static function get_tbl_usage_old($s)
	{
		$obj = array();
		$lines = explode("\n", $s);

		//USER       PID %CPU %MEM    VSZ   RSS TTY      STAT START   TIME COMMAND

		foreach($lines as $line)
		{
			$tds = preg_split('/\s+/', $line);
			$obj[] = $tds;
		}

		//echo '<pre style="font-family:verdana;font-size:10px;">'.print_r($obj, true).'</pre>';die;

		$tbl = array();

		foreach($obj as $v)
		{
			$_n = (isset($v[12]) && strpos($v[12], '.py') > 0)? basename($v[12]) : (isset($v[11])? $v[11] : false);
			
			if($_n && isset($v[3]))
			{
				$_pid = '<a href="#" onclick="kill_process_pthns('.$v[1].'); return false;">'.$v[1].'</a>';
				$tbl[] = array($_pid, $_n, $v[2], $v[3]);
			}
		}

		//echo '<pre style="font-family:verdana;font-size:10px;">'.print_r($tbl, true).'</pre>';die;



		return self :: _tbl($tbl, array('PID', 'Nazwa', 'CPU %', 'Pamięć'));
	}

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	private static function _tbl($obj, $head = array())
	{
		$s = '<table class="list">';

		if(count($head) > 0)
		{
			$s .= '<thead>';
			$s .= self :: _tr($head);
			$s .= '</thead>';
		}
		
		$s .= '<tbody>';
		
		foreach($obj as $v)
			$s .= self :: _tr($v);
		
		$s .= '<tbody>';
		$s .= '</table>';

		return $s;		
	}

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	private static function _tr($obj)
	{
		$s = '<tr>';
		foreach($obj as $v)
			$s .= self :: _td($v);
		$s .= '</tr>';
		return $s;
	}

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	private static function _td($s)
	{
		return '<td>'.$s.'</td>';
	}
}

?>