import sys
import os
import time

ROOT_DIR = os.path.abspath(os.path.join(os.path.dirname( __file__ ), '..'))+"/"
sys.path.append(ROOT_DIR + 'pt/')

from _config_top import *
from read_write import readAllElements

#json_file_save(FILE_HTTP_2SEND, {})

SQL = msqlLite(SQL_PATH)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

def mk2_check2sendHttpAction():
	#global FILE_HTTP_2SEND
	global SQL
	#d = json_file_get(FILE_HTTP_2SEND)
	#print(d)
	d = SQL.getValues('http_2send')
	#print(d)

	if len(d) > 0:
		_k, _v = d.popitem()
		#print(_k, _v)
		http_get(_v, 5)
		#json_file_save(FILE_HTTP_2SEND, d)
		SQL.delVal('http_2send', _k)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

sys_var_spec.init()
sys_var_const.init()

try:
	sys_var_const.set('start_time', datetime.now().strftime("%Y-%m-%d %H:%M"))
	sys_var_const.set('version', mk_php('index.php', 'info version'))
	sys_var_const.set('update_date', mk_php('index.php', 'info update_date'))
except Exception:
	pass


def mk2_updateSpecialVariables():
	global var_var_spec
	
	obj = {}
	
	now = datetime.now()

	g = now.hour
	m = now.minute
	
	_w, _z = fn.sunriseset(now.year, now.month, now.day, {'lat' : LOCALIZATION_LAT, 'long' : LOCALIZATION_LONG})

	wg = _w[0]
	wm = _w[1]
	zg = _z[0]
	zm = _z[1]

	if (g > wg or (g == wg and m >= wm)) and (g < zg or (g == zg and m <= zm)):
		sun = 1
	else:
		sun = 0

	#set 
	obj['hour'] = g
	obj['sunrise'] = var_get(_w, 2, '');
	obj['sunset'] = var_get(_z, 2, '');
	obj['sunshine'] = sun;	

	_weather = fn.getweather(OPENWEATHERMAP_KEY, LOCALIZATION_LAT, LOCALIZATION_LONG)
	obj['weather_temperature'] = _weather['temperature'];
	obj['weather_humidity'] = _weather['humidity'];
	obj['weather_pressure'] = _weather['pressure'];

	for a in obj:
		sys_var_spec.set(a, obj[a])	

if PLATFORM == 'win':
	print('mk2 start')

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

try:
	
	sys_err.init()
	mk2_updateSpecialVariables()

	sec = 0
	
	while True:

		#co 5 sekund
		if sec % 5 == 0:
			mk2_check2sendHttpAction()

		#co minute
		if sec % 60 == 0:
			sys_workingModules.set('mk2')
			sys_info.set_usage()
			sys_err.set('connections_list', sys_conn_error.get())
			sys_err.set('connections', 1 if sys_conn_error.is_err() == True else 0)
			sys_err.set('modules', 1 if sys_workingModules.is_err() == True else 0)
			sys_err.set('modules_list', sys_workingModules.getErr())

		sec = sec + 1

		if sec == 3600:
			mk2_updateSpecialVariables()
			sec = 1			

		time.sleep(1)

except KeyboardInterrupt:
	print('Koniec')