import os
import sys
import socket
import time

ROOT_DIR = os.path.abspath(os.path.join(os.path.dirname( __file__ ), '..'))+"/"
sys.path.append(ROOT_DIR + 'pt/')

from _config_top import *

SQL = msqlLite(SQL_PATH)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

IPS = []

def makeStartData():
	global FILE_CONFIG
	global IPS

	obj = json_file_get_var(FILE_CONFIG, 'devices', {})
	
	for a in obj:
		if a['typ'] == 'comp' and is_eq_int(a, 'aktywny', 1) :
			IPS.append({'nazwa': a['nazwa'], 'ip' : a['ip']})

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

makeStartData()
save = {}

for a in IPS:
	save[a['nazwa']] = 0

SQL.setValues('pings', save)

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

if PLATFORM == 'win':
	print('pings start')

current = 0
x = 0;

try:

	while True:

		if len(IPS) > 0 and (x == 10 or x%60) == 0:	#co minute

			sys_workingModules.set('pings')
			
			c = IPS[current]
			n = c['nazwa']
			ip = c['ip']

			ok = ping_host(ip)

			act = SQL.getVal('pings', n)
			
			if ok:
				if act == 0 or act == '0':
					ret = time.strftime('%m-%d %H:%M')#time.strftime('%Y-%m-%d %H:%M:%S')
				else:
					ret = act
			else:
				ret = 0

			current = current+1

			if current >= len(IPS):
				current=0

			SQL.setVal('pings', n, ret)

		x = x + 1

		if x == 600: #10 minut
			makeStartData()
			x = 11

		time.sleep(1)

except KeyboardInterrupt:
	print('Koniec')