import os
import sys
import time

ROOT_DIR = os.path.abspath(os.path.join(os.path.dirname( __file__ ), '..'))+"/"
sys.path.append(ROOT_DIR + 'pt/')

from _config_top import *
from lib.rxtx_class import *

OUT = []

def cc (str):
	global OUT
	if len(str) > 0:
		OUT.append(str)

if len(RFLINK_PORT) > 0:
	rf = rxtx(RFLINK_PORT, 57600, 0.1)
	rf.setReadEvt(cc)
	rf.start()
else:
	rf = False

#CMD =var_get(sys.argv, 1, 'read_all')

x = 1
ok = True

try:
	
	while ok: 
				
		x = x + 1
		
		if x == 10:
			ok = False
		
		time.sleep(1)
 
except KeyboardInterrupt:
	print('Koniec') 
	if rf:
		rd.stop()

if rf:
	rf.stop()
	
jstr = json.dumps(OUT)
print(jstr)