<?php

class html
{
	public static function table($obj, $opt = array())
	{
		$rows = [];

		foreach($obj as $k => $v)
		{
			$rows[] = '<tr><td>'.$k.'</td><td>'.$v.'</td></tr>';
		}
		return '<table class="'.arr :: get($opt, 'class', 'table').'">'.join('', $rows).'</table>';
	}

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	
	public static function tbl($obj, $opt = array())	
	{
		$s = '<div class="'.arr :: get($opt, 'class', 'tbl').'">';
		$repl = arr :: get($opt, 'replace', array());
		$only_val = arr :: get($opt, 'only_val');
		
		foreach($obj as $k => $v)	
		{
			if(is_array($v))
				$val = '-array-';
			else if($v > '' && array_key_exists($v.'', $repl))
				$val = $repl[$v];
			else
				$val = $v;

			if($only_val)
				$s .= '<div class="tr"><div class="td">'.$val.'</div></div>' . "\n";
			else
				$s .= '<div class="tr"><div class="td">'.(is_array($k)? '-array-' : $k).'</div><div class="td">'.$val.'</div></div>' . "\n";
		}

		$s .= '</div>';

		return $s;		
	}
	
	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	public static function template_get($n, $confObj = array())
	{
		$obj = configuration :: getTemplates($confObj);
		return arr :: get($obj, $n, array());
	}

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	public static function mk_elem($conf)
	{
		//$elemDisp = configuration :: getElementsDesc('start');
		$elemDisp = modules :: get_start_elem();

		$s = '<div id="menuZakContainer"></div>';
		$s .= '<div>';
		
		foreach($elemDisp as $k => $v)
		{
			$_e = arr :: get($conf, $k, array());
			$s .= self :: mk_elem_opt($k, $_e, $v['name'], $v['ico']);//, $v['desc']
			//$s .= $v['name'] . '<br><br>';
		}

		$s .= '</div>';		
		$s .= '<script type="text/javascript">

		$(function(){
			rpih.read_all();
		});	
		
		</script>';		

		return $s;
	}

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	public static function mk_ic($ic, $is_min = false)
	{
		if($ic > '')
		{
			if(strpos($ic, '.png') > 0)
				return '<span class="module_ico mgr-10"><img src="'.$ic.'" alt="" title=""></span>';
			else
				return '<span class="module_ico '.($is_min? 'min' : '').' mgr-10"><i class="fa '.$ic.'" aria-hidden="true"></i></span>';		
		}
			else return '';
	}

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	public static function mk_elem_opt($t, $obj, $n = false, $ic = '', $desc='')
	{
		$s = '';

		if($n)
		{
			$linkEdit = configuration :: isValidElement($t)? '<a href="?a=form_edit&b='.$t.'" class="link c-white">edytuj</a>' : '' ;

			//$ic = $ic? '<span style="width:40px;" class="ib center"><i class="fa '.$ic.'" aria-hidden="true"></i></span>' : '';
			$ic = self :: mk_ic($ic);
			//$s .= '<div class="tbl full emNag"><div class="td" style="width:30%;">'.$ic.'<h3>'.$n.'</h3></div><div class="td l pdr-10">';
			//$s .= '<div class="tbl full"><div class="td l m c-white f-min">'.$desc.'</div><div class="td r">'.$linkEdit.'</div></div>';
			//$s .= '</div></div>';
		}

		$ident2height = md5($n);
		
		if(count($obj) > 0)
		{
			$s .= '<div class="elem six mgt-5 mgb-20">';

			$s .= '<div class="em emFields zazn">
				<div data-css-all-h="elem_ster_1_'.$ident2height.'">
					<div class="tbl"><div class="td m pdt-5 f-plus">'.$ic.'</div><div class="td m"><h3>'.$n.'</h3></div></div>		
					<div class="f-min">'.$desc.'</div>
				</div>
				<div data-css-all-h="elem_ster_2_'.$ident2height.'" class="right">
					'.$linkEdit.'
				</div>
			</div>';


			foreach($obj as $v)
			{
				$name = $v['nazwa'];

				if(!isset($v['typ']))
					$v['typ'] = '';

				if($t == 'variables')
				{
					if($v['typ'] == 'yn')
						$click = '<a href="#" class="elemPanelBtn" onclick="rpih.elemSetToggle(\''.$name.'\'); return false;">tak/nie</a>';
					else if($v['typ'] == 'counter')
					{
						$click = '<a href="#" class="elemPanelBtn" onclick="rpih.elemSetAction(\''.$name.'\', 0, 1); return false;">reset</a>';
						$click .= '<a href="#" class="elemPanelBtn" onclick="rpih.elemSetAction(\''.$name.'\', prompt(\'Wartość\')); return false;">dodaj</a>';
					}
					else if($v['typ'] == 'text')
						$click = '<a href="#" class="elemPanelBtn" onclick="rpih.elemSetAction(\''.$name.'\', prompt(\'Wartość\'), \'~\'); return false;">ustaw</a>';
					else
						$click = '<a href="#" class="elemPanelBtn" onclick="rpih.elemSetAction(\''.$name.'\', prompt(\'Wartość\')); return false;">ustaw</a>';
				}
				else if($t == 'ports' || $t == 'i2c')
				{
					if($v['typ'] == 'element')
						$click = '';
					else
						$click = '<a href="#" class="elemPanelBtn" onclick="rpih.elemSetAction(\''.$name.'\', prompt(\'Komenda\')); return false;">wyślij</a>';
				}
				else if($t == 'rs485')
				{
					if($v['typ'] == 'definicja')
						$click = '<a href="#" class="elemPanelBtn" onclick="rpih.elemSetAction(\''.$name.'\', prompt(\'Komenda\')); return false;">wyślij</a>';
					else if($v['typ'] == 'element')
					{
						$click = '<a href="#" class="elemPanelBtn" onclick="rpih.elemSetAction(\''.$name.'\', prompt(\'Komenda\')); return false;">wyślij</a>';
						$click .= '<a href="#" class="elemPanelBtn" onclick="rpih.elemSetToggle(\''.$name.'\'); return false;">przełącz</a>';
					}
					else
						$click = '';
				}
				else if($t == 'rflink')
				{
					$cmds = explode(';', $v['komendy']);
					$click = [];

					foreach($cmds as $c)
						$click[] = '<a href="#" class="elemPanelBtn" onclick="rpih.elemSetAction(\''.$name.'\', \''.$c.'\'); return false;">'.$c.'</a>';

					$click = join(' ', $click);
				}
				else if($t == 'events' || $t == 'time' || $t == 'tasks')
				{
					$click = '<a href="#" class="elemPanelBtn" onclick="rpih.elemSetAction(\''.$name.'\', 1); return false;">uruchom</a>';
				}
				else if($t == 'zigbee')
				{
					$click = '<a href="#" class="elemPanelBtn" onclick="rpih.elemSetToggle(\''.$name.'\'); return false;">on/off</a>';
				}
				else if($v['typ'] == 'out_d_0')
					$click = '<a href="#" class="elemPanelBtn" onclick="rpih.elemSetToggle(\''.$name.'\'); return false;">on/off</a>';
				else if($v['typ'] == 'pwm')
				{
					$click = '<a href="#" class="elemPanelBtn" onclick="rpih.elemPwm(\''.$name.'\', \'toggle\'); return false;">on/off</a>';
					$click .= ' ';
					$click .= '<a href="#" class="elemPanelBtn" onclick="rpih.elemPwm(\''.$name.'\', \'fill\', prompt(\'Wypełnienie\'));  return false;">wyp</a>';
				}
				else if($v['typ'] == 'afe_1ch')
					$click = '<a href="#" class="elemPanelBtn" onclick="rpih.elemSetToggle(\''.$name.'\'); return false;">tak/nie</a>';
				else if($v['typ'] == 'comp')
					$click = '<a href="#" class="elemPanelBtn" onclick="rpih.elemSetToggle(\''.$name.'\'); return false;">tak/nie</a>';
				else if($t == 'cameras')
				{
					$click = '<a href="#" class="elemPanelBtn" onclick="rpih.elemSetAction(\''.$name.'\', -1); return false;">zapisz w data/cam_images/</a>';
					$click .= '<br><a href="#" class="elemPanelBtn" onclick="rpih.elemCamImage(\''.$name.'\'); return false;">pokaż</a>';
				}
				else if($v['typ'] == 'lk2' || $v['typ'] == 'lk3')
				{
					$fields = explode(';', $v['param']);
					$click = '<div class="flexList flexMin">';
					
					foreach($fields as $pp)
					{
						$click .= '<div class="flexItem">';
						$_pp = explode('=', $pp);
						if(count($_pp) > 1)
						{
							$_ns = $name . '.' . $_pp[0];
							$_nv = '<span title="' . ($_pp[0] . ' > ' . $_pp[1]) . '">' . $_pp[0] . '</span>';
						}
						else
						{
							$_ns = $name . '.' . $pp;
							$_nv = $pp;							
						}
						
						$_blink_gw = '<span class="setChange" style="color:transparent;" data-ident-res-blink="'.$_ns.'"><i class="fa fa-star" aria-hidden="true"></i></span>';
						$_res = '<span data-ident-res="'.$_ns.'" data-ident-type="">...</span>';
						$click .= '<span class="elemPanelBtn" onclick="rpih.elemSetToggle(\''.$_ns.'\'); return false;"><span class="f-min nw">'.$_nv.'</span><br>'.$_res.''.$_blink_gw.'</span>';
						


						$click .= '</div>';
					}

					$click .= '</div>';
				}
				else
					$click = '<a href="#" onclick="return false;">&nbsp;</a>';

				if($t == 'devices' || $t == 'cameras' || $t == 'rs485' || $t == 'i2c' || $t == 'events' || $t == 'time' || $t == 'tasks' || $t == 'script')
				{
					$is_active = isset($v['aktywny']) && $v['aktywny']==1;
					$activeLink = 'index.php?a=data_actions&action=elements_set_active&type='.$t.'&name='.$v['nazwa'];					
					$activeLink = '<span class="ch_active" onclick="page.sendQuery(\''.$activeLink.'\');"><span class="'.($is_active? 'now_0' : 'now_1').'">on</span>/<span class="'.($is_active? 'now_1' : 'now_0').'">off</span></span>';	
				}
				else
				{
					$is_active = true;
					$activeLink = '';
				}

				$s .= '<div class="em">
							<div class="emFields '.($is_active? '' : 'inactive').' rel">
								<div data-css-all-h="elem_ster_1_'.$ident2height.'">
									'.($v['opis'] > '' ?'<div style="min-height:10px;">'.$v['opis'].'</div>' : '').'
									<div>
										<div class="tbl full"><div class="td l t name" style="">'.$v['nazwa'].'</div><div class="td r t">'.$activeLink.'</div></div>
									</div>
									'.($t != 'devicesfsdfsf'? '<div class="mgt-5 value" data-ident-res="'.$name.'" data-ident-type="'.(isset($v['typ'])? $v['typ'] : $t).'">...</div>' : '').'
								</div>
								<div data-css-all-h="elem_ster_2_'.$ident2height.'">
									<div class="right">'.$click.'</div>
								</div>
								<div class="abs-right-top mgt-5 mgr-5 setChange" style="color:transparent;" data-ident-res-blink="'.$name.'"><i class="fa fa-star" aria-hidden="true"></i></div>
							</div>							
						</div>';
			}

			$s .= '</div>';
		}
		else
		{
			//$s .= '<div class="mgt-5 mgb-10">--brak elementów---</div>';
		}

		return $s;
	}

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	public static function mk_form($conf)
	{		
		$pinsStrAdd1 = 'onclick="box.show(\'img\', \'_img/raspberry_pins.png\', \'max-width:500px;\', \'background:#fff; padding:10px;\');"';
		$pinsStrAdd1 = '<h4>Rozkład pinów</h4><br><div style="width:100%; max-height:300px; background:center center no-repeat url(_img/raspberry_pins.png); background-size:contain; cursor:pointer;" data-css-hs="0.9" '.$pinsStrAdd1.'>&nbsp;</div>';
		$pinsStrAdd2 = configuration :: getUsedGpioHtml($conf);
		$pinsStrAdd = '<div class="tbl full"><div class="td" style="width:70%;">'.$pinsStrAdd1.'</div><div class="td">'.$pinsStrAdd2.'</div></div>';

		$pinsStr = self :: getElementsFields('gpio', $conf, ['firstElement' => $pinsStrAdd]);
		$warsStr = self :: getElementsFields('variables', $conf, ['elemCount' => 'five']);
		$eventsStr = self :: getElementsFields('events', $conf);
		$timeStr = self :: getElementsFields('time', $conf);	
		$portsStr = self :: getElementsFields('ports', $conf);
		$rs485Str = self :: getElementsFields('rs485', $conf);
		$i2cStr = self :: getElementsFields('i2c', $conf);
		$rflinkStr = self :: getElementsFields('rflink', $conf);	
		$zigbeeStr = self :: getElementsFields('zigbee', $conf);	
		$devicesStr = self :: getElementsFields('devices', $conf);
		$camerasStr = self :: getElementsFields('cameras', $conf);
		$tasksStr = self :: getElementsFields('tasks', $conf, ['elemCount' => 'two']);

		$main_conf = '<div class="elem three"><div class="em"><div class="emFields" data-css-all-h="conf-main"><h3 class="mgb-10">Autoryzacja</h3>';
		$main_conf .= self :: getField(['name' => 'Użytkownik'], 'access[user]', arr :: getm($conf, 'access.user', ''));
		$main_conf .= self :: getField(['name' => 'Hasło'], 'access[passwd]', arr :: getm($conf, 'access.passwd', ''));
		$main_conf .= '</div></div><div class="em"><div class="emFields" data-css-all-h="conf-main"><h3>Podstawowe</h3>';

		foreach(self :: template_get('parameters') as $k => $v)
		{
			$opts = ['desc' => arr :: get($v, 'desc')];
			
			if(arr :: get($v, 'type') == 'sep')
			{
				$main_conf .= '</div></div><div class="em"><div class="emFields" data-css-all-h="conf-main">';
				$main_conf .= '<h3 class="mgt-10 bold">'.arr :: get($v, 'name', '').'</h3>';
			}
			else
				$main_conf .= '<p class="mgb-5">'.self :: getField($v, 'parameters['.$k.']', arr :: getm($conf, 'parameters.'.$k, ''), $opts) . '</p>';
		}
		$main_conf .= '</div></div></div>';

		$content ='<div data-zak-name="Elementy">'.$pinsStr.'</div>';
		$content .='<div data-zak-name="Zmienne">'.$warsStr.'</div>';
		$content .='<div data-zak-name="Zdarzenia">'.$eventsStr.'</div>';
		$content .='<div data-zak-name="Czasowe zadania">'.$timeStr.'</div>';
		$content .='<div data-zak-name="Zadania">'.$tasksStr.'</div>';
		$content .='<div data-zak-name="Porty">'.$portsStr.'</div>';
		$content .='<div data-zak-name="RS 485">'.$rs485Str.'</div>';
		$content .='<div data-zak-name="I2C">'.$i2cStr.'</div>';
		$content .='<div data-zak-name="RFLink">'.$rflinkStr.'</div>';
		//$content .='<div data-zak-name="Zigbee">'.$zigbeeStr.'</div>';
		$content .='<div data-zak-name="Urządzenia zewnętrzne">'.$devicesStr.'</div>';
		$content .='<div data-zak-name="Kamery">'.$camerasStr.'</div>';
		$content .='<div data-zak-name="Konfiguracja">'.$main_conf.'</div>';

		
		$all = '<div id="menuZakContainer"></div>';
		$all .= '<form action="index.php?a=save_data" method="post" onsubmit="rpih.hash_form(this, \'_hashStr\'); this.elements[\'_idn\'].value=location.hash;">';
		$all .= '<p>&nbsp;</p>'.$content.'';	

		
		$all .= '<input type="hidden" name="_idn" value="">';
		$all .= '<input type="hidden" name="_hashStr" value="">';
		$all .= '<input type="submit" value="zapisz" class="saveAll">';
		$all .= '</form>';

		$all .= '
		<script>
		$(function(){
			rpih.init();
			rpih.read_all();
		});	

		var conf_zak = new zak("#menuZakContainer");//, null, "data-zak-ico");
		conf_zak.name = "conf-menu";
		//help_zak.swipe = true;
		//help_zak.addFunctionFor("user", "update_all_diagrams");
		conf_zak.start();

		</script>
		';

		return $all;
	}

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	public static function mk_form_parameters($conf)
	{
		$s = '<form action="index.php?a=save_data&b=parameters" method="post" data-panel="true" onsubmit="rpih.hash_form(this, \'_hashStr\');">';

		$s .= '<div class="elem three">';

		$obj = self :: template_get('parameters');

		foreach($obj as $k1 => $v1)
		{
			$s .= '<div class="em"><div class="emFields" data-css-all-h="conf-main"><h3 class="mgb-20">'.$v1['name'].'</h3><div class="mgl-20 mgr-10 mgb-20">';
			
			foreach($v1['fields'] as $k2 => $v2)
			{
				$opts = ['desc' => arr :: get($v2, 'desc')];
				$s .= '<div class="mgt-5">' . self :: getField($v2, 'parameters['.$k1.']['.$k2.']', arr :: getm($conf, array('parameters', $k1, $k2), ''), $opts) . '</div>';
			}
			if(($_desc = arr :: get($v1, 'desc', '')) > '')
				$s .= '<div class="mgt-20 f-min">'.$_desc.'</div>';

			$s .= '</div></div></div>';
		}

		$s .= '</div>';

		$s .= '<input type="hidden" name="_hashStr" value="">';
		$s .= '<input type="submit" value="zapisz" class="saveAll">';
		$s .= '</form>';

		$s .= '
		<script>
		$(function(){
			rpih.init();
			rpih.read_all();
		});

		</script>
		';

		return $s;
	}

	public static function mk_form_parameters_old($conf)
	{
		$s = '<form action="index.php?a=save_data&b=parameters" method="post" onsubmit="rpih.hash_form(this, \'_hashStr\');">';
		$s .= '<div class="elem three"><div class="em"><div class="emFields" data-css-all-h="conf-main"><h3 class="mgb-20">Autoryzacja</h3><div class="mgl-20">';
		$s .= self :: getField(['name' => 'Użytkownik'], 'access[user]', arr :: getm($conf, 'access.user', ''));
		$s .= self :: getField(['name' => 'Hasło'], 'access[passwd]', arr :: getm($conf, 'access.passwd', ''));
		$s .= '</div></div></div><div class="em"><div class="emFields" data-css-all-h="conf-main"><h3 class="mgb-20">Podstawowe</h3><div class="mgl-20">';
		echo '<pre style="font-family:verdana;font-size:10px;">'.print_r(self :: template_get('parameters'), true).'</pre>';
		
		foreach(self :: template_get('parameters') as $k => $v)
		{
			$opts = ['desc' => arr :: get($v, 'desc')];
			
			if(arr :: get($v, 'type') == 'sep')
			{
				$s .= '</div></div></div><div class="em"><div class="emFields" data-css-all-h="conf-main">';
				$s .= '<h3 class="mgb-20">'.arr :: get($v, 'name', '').'</h3><div class="mgl-20">';
			}
			else
				$s .= '<p style="margin-bottom:5px;">'.self :: getField($v, 'parameters['.$k.']', arr :: getm($conf, 'parameters.'.$k, ''), $opts) . '</p>';
		}
		$s .= '</div></div></div></div>';

		$s .= '<input type="hidden" name="_hashStr" value="">';
		$s .= '<input type="submit" value="zapisz" class="saveAll">';
		$s .= '</form>';

		$s .= '
		<script>
		$(function(){
			rpih.init();
			rpih.read_all();
		});

		</script>
		';

		return $s;
	}

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	public static function mk_form_element($conf, $elementIdent)
	{
		$s = '<form action="index.php?a=save_data&b='.$elementIdent.'" method="post" data-panel="true" onsubmit="rpih.hash_form(this, \'_hashStr\');">';
		$s .= self :: getElementsFields($elementIdent, $conf);

		$s .= '<input type="hidden" name="_idn" value="">';
		$s .= '<input type="hidden" name="_hashStr" value="">';
		$s .= '<input type="submit" value="zapisz" class="saveAll">';
		$s .= '</form>';

		$s .= '
		<script>
		$(function(){
			rpih.init();
			rpih.read_all();
		});

		</script>
		';

		return $s;		
	}

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	private static function getElementsFields($type, $confObj, $opt = array())
	{		
		$elem = arr :: get($confObj, $type, array());

		$tplData = self :: template_get($type, $confObj);

		$retEm = array();

		if(($_s = arr :: get($opt, 'firstElement', '')) > '')
			$retEm[] = '<div class="em"><div class="emFields" data-css-all-h="em-fields-'.$type.'">' . $_s . '</div></div>';

		$x = 0;

		foreach($elem as $k => $v)
		{
			$retEm[] = '<div class="em">' . self :: getEmFields($tplData, $type, $k, $v) . '</div>';
			$x = $k+1;
		}

		$retEm[] = '<div class="em">' . self :: getEmFields($tplData, $type, $x, false) . '</div>';

		$s = '<div class="elem '.arr :: get($opt, 'elemCount', 'four').'">' . join('', $retEm) . '</div>';

		return $s;
	}

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	private static function getEmFields($templateData, $type, $nr, $obj = array())
	{
		$i = 0;
		$s = '';
		static $is_emFieldElem = false;
		static $is_emFieldTable = false;

		if(array_key_exists('_na', $templateData))
		{
			$n = array(
				'-2500' => array('type' => '_tbl_start', 'count' => 'two'),
				'nazwa' => array('name' => $templateData['_na'][0], 'type' => 'text', 'pattern' => '[a-zA-Z0-9_\-]{2,}'),
				'aktywny' => array('name' => 'Aktywność', 'type' => 'checked'),
				'-2501' => array('type' => '_tbl_end'),
			);

			unset($templateData['_na']);
			$templateData = array_merge($n, $templateData);
		}
		//echo '<pre style="font-family:verdana;font-size:10px;">'.print_r($templateData, true).'</pre>';die;

		foreach($templateData as $k => $v)
		{
			$opt = ($obj === false && $i == 0)? ['placeholder' => 'nowy'] : [] ;

			$opt['grp_id'] = 'grp_id-'.$type.'-'.$nr.'';
			$opt['desc'] = arr :: get($v, 'desc', '');
			$opt['pattern'] = arr :: get($v, 'pattern');

			if(isset($v['avail']))
			{
				list($_a1, $_a2, $_a3) = explode(':', $v['avail'].'::');
				$opt['avail_to'] = '-doom:select#'.$opt['grp_id'].'[name*=\''.$_a1.'\'];'.$_a2.''.($_a3>''?';'.$_a3:'');
			}

			$_t = arr :: get($v, 'type');

			if($_t == '_elem_start')
			{
				$s .= '<div class="elem '.arr :: get($v, 'count', 'two').'">';
				$is_emFieldElem = true;
			}
			else if($_t == '_elem_end')
			{
				$s .= '</div>';
				$is_emFieldElem = false;
			}
			else if($_t == '_flex_start')
			{
				$s .= '<div class="flexList">';
				$is_emFieldElem = true;
			}
			else if($_t == '_flex_end')
			{
				$s .= '</div>';
				$is_emFieldElem = false;
			}			
			else if($_t == '_tbl_start')
			{
				$s .= '<div class="tbl full">';
				$is_emFieldTable = true;
			}
			else if($_t == '_tbl_end')
			{
				$s .= '</div>';
				$is_emFieldTable = false;
			}
			else if($_t == '_desc')
			{
				$s .= '<div class="em center"><label>'.arr :: get($v, 'value', '').'</label></div>';
			}
			else if($_t == '_odst')
			{
				$s .= '<div class="">&nbsp;</div>';
			}			
			else
			{
				if($is_emFieldElem)
					$s .= '<div class="em">';
				else if($is_emFieldTable)
					$s .= '<div class="td">';
				
				$s .= self :: getField($v, $type . '['.$nr.']['.$k.']', arr :: get($obj, $k, ''), $opt);

				if($is_emFieldElem || $is_emFieldTable)
					$s .= '</div>';

				$i++;
			}			
		}

		$actions = '';
		$actions .= '<a href="#" onclick="$(\'div[data-css-all-h=em-fields-'.$type.'][data-type-nr2clear='.$nr.'] *\').val(\'\'); return false;" class="link">wyczyść</a>';
		$actions .= '&nbsp;|&nbsp;';
		$actions .= '<a href="#" onclick="location.href=\'index.php?a=data_actions&action=up&type='.$type.'&nr='.$nr.'\'; return false;" class="link">w górę</a>';
		$actions .= '&nbsp;|&nbsp;';
		$actions .= '<a href="#" onclick="location.href=\'index.php?a=data_actions&action=down&type='.$type.'&nr='.$nr.'\'; return false;" class="link">w dół</a>';
		$actions = '<div class="right f-min">'.$actions.'</div>';
		
		return '<div class="emFields" data-css-all-h="em-fields-'.$type.'" data-type-nr2clear="'.$nr.'">' . $actions . $s . '</div>';
	}

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	public static function getField($obj, $name, $val = '', $opt = array())
	{
		$dat = isset($opt['avail_to'])? 'data-avail-to="'.$opt['avail_to'].'"' : '';

		$s = '<div '.$dat.'>';		
		
		$_label = arr :: get($obj, 'name', '');
		$_type = arr :: get($obj, 'type', 'text');
		$_options = arr :: get($obj, 'options', []);
		$_pattern = arr :: get($obj, 'pattern');
		$_step = arr :: get($obj, 'step');
		$_help = arr :: get($obj, 'help');
		$_css = arr :: get($obj, 'css');

		$_css = $_css? self :: _css_strx($_css) : '' ;
		
		$_help_str = $_help? '<i class="fa fa-question-circle href" aria-hidden="true" data-help-box-popup="'.$_help.'"></i>' : '' ;

		if($_label > '')
			$s .= '<label for="">'.$_label.''.($_help_str? ' ' . $_help_str : '').'</label><br>';
		else if($_help_str)
			$s .= $_help_str . '<br>';

		if($_type == 'select')
		{
			//$s .= '<select name="'.$name.'" '.(isset($opt['grp_id'])? 'id="'.$opt['grp_id'].'"' : '').' style="'.arr :: get($opt, 'styles', '').'">';
			$s .= '<select name="'.$name.'" '.(isset($opt['grp_id'])? 'id="'.$opt['grp_id'].'"' : '').' '.$_css.'>';			
			$s .= '<option value=""> --- </option>';
			foreach($_options as $k => $v)
				$s .= '<option value="'.$k.'" '.($k == $val? 'selected' : '').'>'.$v.'</option>';
			$s .= '</select>';
		}
		else if($_type == 'checkboxes')
		{
			//echo '<pre style="font-family:verdana;font-size:10px;">'.print_r($val, true).'</pre>';die;
			foreach($_options as $k => $v)
				$s .= '<p><input type="checkbox" name="'.$name.'[]" value="'.$k.'" '.(is_array($val) && in_array($k, $val)? 'checked' : '').' '.$_css.'>'.$v.'</p>';
		}
		else if($_type == 'checked')
			$s .= '<p><input type="checkbox" name="'.$name.'" value="1" '.($val == 1? 'checked' : '').' '.$_css.'></p>';
		else if($_type == 'op')
			$s .= '<div>'.arr :: get($obj, 'op').'</div>';
		else if($_type == 'arr')	
		{
			$s1 = ''; $s2 = '';
			foreach($_options as $k => $v)
			{
				$s1 .= '<div class="td"><label>'.$v.'</label></div>';
				$s2 .= '<div class="td"><input type="text" name="'.$name.'['.$k.']" value="'.arr::get($val, $k, '').'" '.$_css.'></div>';
			}
			$s .= '<div class="fields_arr"><div class="tbl full"><div class="tr">'.$s1.'</div><div class="tr">'.$s2.'</div></div></div>';
		}
		else if($_type == 'textarea')
			$s .= '<textarea name="'.$name.'" '.$_css.'>'.$val.'</textarea>';
		else
		{
			if(is_array($val))
				$val = join(';', $val);

			$_pl = arr :: get($opt, 'placeholder', '');

			//if($name != 'name')
			if(preg_match('/\[[0-9]{1,}\]\[nazwa\]$/', $name))
			{
				$jsc = 'onfocus="asdx.start(this);" onfocusout="asdx.stop(this);" onkeyup="asdx.check(this);"';
				//$jsc = 'style="background-color:red !important;"';
			}
			else
				$jsc = '';
			
			$s .= '<input type="'.$_type.'" name="'.$name.'" '.$jsc.' value="'.$val.'" placeholder="'.$_pl.'" '.($_pattern? 'pattern="'.$_pattern.'"' : '').' '.($_step? 'step="'.$_step.'"' : '').' '.$_css.'>';
		}

		if(isset($opt['desc']) && $opt['desc'] > '')
			$s .= '<div class="field_desc">'.$opt['desc'].'</div>';
		
		$s .= '</div>';
		
		return $s;
	}

	private static function _css_strx($x)	{		
		return $x? ('style="' . (is_array($x)? join(';', $x) : $x) . ';"') : '' ;
	}

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	
	public static function header($n = false, $dot_elem = array())
	{
		$title = 'Raspbery iHome Controler';
//echo '<pre style="font-family:verdana;font-size:10px;">'.print_r($_SERVER, true).'</pre>';die;
		$s = '<html lang="pl-PL"><head>';


		//echo '<pre style="font-family:verdana;font-size:10px;">'.print_r($_SERVER, true).'</pre>';die;

		$_rr = http :: _get('_rr', 0);
		if($_rr){

			$_ox = substr($_SERVER['REQUEST_URI'], -1) != '/'? 1 : 0;
			$s .= '<base href="'.str_repeat('../', $_rr-$_ox).'">';
		}
		else
			$s .= '<base href="./">';

		$s .= '<title>'.$title.'</title>';

		$s .= '<meta http-equiv="content-type" content="text/html; charset=UTF-8">';

		$s .= '
		<link rel="apple-touch-icon" sizes="57x57" href="_img/ico/apple-icon-57x57.png">
		<link rel="apple-touch-icon" sizes="60x60" href="_img/ico/apple-icon-60x60.png">
		<link rel="apple-touch-icon" sizes="72x72" href="_img/ico/apple-icon-72x72.png">
		<link rel="apple-touch-icon" sizes="76x76" href="_img/ico/apple-icon-76x76.png">
		<link rel="apple-touch-icon" sizes="114x114" href="_img/ico/apple-icon-114x114.png">
		<link rel="apple-touch-icon" sizes="120x120" href="_img/ico/apple-icon-120x120.png">
		<link rel="apple-touch-icon" sizes="144x144" href="_img/ico/apple-icon-144x144.png">
		<link rel="apple-touch-icon" sizes="152x152" href="_img/ico/apple-icon-152x152.png">
		<link rel="apple-touch-icon" sizes="180x180" href="_img/ico/apple-icon-180x180.png">
		<link rel="icon" type="image/png" sizes="192x192"  href="_img/ico/android-icon-192x192.png">
		<link rel="icon" type="image/png" sizes="32x32" href="_img/ico/favicon-32x32.png">
		<link rel="icon" type="image/png" sizes="96x96" href="_img/ico/favicon-96x96.png">
		<link rel="icon" type="image/png" sizes="16x16" href="_img/ico/favicon-16x16.png">
		<link rel="manifest" href="_img/ico/manifest.json">
		<meta name="msapplication-TileColor" content="#ffffff">
		<meta name="msapplication-TileImage" content="_img/ico/ms-icon-144x144.png">
		';

		$s .= '<script src="_js/jquery-1.11.3.js"></script>';
		$s .= '<script src="_js/jquery-ui.min.js?'.VERSION.'"></script>';
		$s .= '<script src="_js/chart.min.js?'.VERSION.'"></script>';
		$s .= '<script src="_js/page.js?'.VERSION.'"></script>';
		$s .= '<script src="_js/box.js?'.VERSION.'"></script>';
		$s .= '<script src="_js/panel.js?'.VERSION.'"></script>';
		$s .= '<script src="_js/md5.js?'.VERSION.'"></script>';		
		$s .= '<script src="_js/ihome-logo-min.js?'.VERSION.'"></script>';
		$s .= '<script src="_js/zak.js?'.VERSION.'"></script>';
		$s .= '<script src="_js/rp-i.js?'.VERSION.'"></script>';
		//$s .= '<script src="_js/mqtte.js?'.VERSION.'"></script>';
		$s .= '<script src="_js/diagram-designer-min.js?'.VERSION.'"></script>';
		//$s .= '<script src="../../ihome/diagram-designer-min.js?'.VERSION.'"></script>';
		$s .= '<script src="_js/funct.js?'.VERSION.'"></script>';

		$s .= '<meta name="viewport" content="width=device-width, initial-scale=1">';

		//$s .= '<base href="http://'.$_SERVER['HTTP_HOST'].'/ihome-raspberry/_content/" />';

		if(DARK_MODE_DISP)
			$s .= '<link href="css/mode_dark.css?'.VERSION.'" rel="stylesheet" type="text/css">';
		else
			$s .= '<link href="css/mode_light.css?'.VERSION.'" rel="stylesheet" type="text/css">';

		$s .= '<link href="css/start.css?'.VERSION.'" rel="stylesheet" type="text/css">';
		$s .= '<link href="css/styles.css?'.VERSION.'" rel="stylesheet" type="text/css">';
		$s .= '<link href="css/tbl.css?'.VERSION.'" rel="stylesheet" type="text/css">';
		$s .= '<link href="css/elem.css?'.VERSION.'" rel="stylesheet" type="text/css">';
		$s .= '<link href="css/res.css?'.VERSION.'" rel="stylesheet" type="text/css">';
		$s .= '<link href="packages/font-awesome/css/font-awesome.min.css?'.VERSION.'" rel="stylesheet" type="text/css">';

		$s .= '<script>$(function(){page.init();});</script>';

		$form_def_help = parse_ini_file("src/form_def_help.html");
		//echo '<pre style="font-family:verdana;font-size:10px;">'.print_r($form_def_help, true).'</pre>';die;

		$s .= '<script>

		FORM_DEF_HELP = {};
		';

		foreach($form_def_help as $k => $v)
			$s .= 'FORM_DEF_HELP["'.$k.'"] = "'.str_replace(array("\r", "\n", ""), "", nl2br(trim($v))).'";';

		$s .= <<< JAVASCRIPT

		function wait_alert(str)
		{
			box.show("alert", str, page.getLoader());
		}

		function endmsg(str)
		{
			let id = page.uniqid("endmsg_");
			$('body').append('<div class="endmsgBox" id="'+id+'">'+str+'</div>');
			setTimeout(() => { this._endmsg_end(id); }, 2000 );
		}
		function _endmsg_end(id)
		{
			$('div#' + id).slideUp(100, () => { $("div#" + id).remove() });
		}			

		$(function(){

			panel.init("Szybki dostęp", "#panelLockDv", ['back', 'scrollTop', 'submit']);			

			$("*[data-help-box-popup]").click(function(){
				let str = $(this).attr("data-help-box-popup");

				if(str.indexOf("def:") === 0)
				{
					let co = str.substr(4);
					let oco = co.split(",");
					let strObj = [];

					for(let a in oco)
						strObj.push(FORM_DEF_HELP[oco[a]] || "(no-help " + oco[a] + ")");

					str = strObj.join("<hr>");
				}

				box.show("html", str);
			});

			if($('#importants_list_disp').length == 1)
			{
				var _f = () => {
					let _s1 = '', _s2 = '';
					$.ajax({url:'index.php?a=read_important', async:true, dataType:'json'}).done((dt) => {
						
						for(let a in dt.err_connections_list)
							_s1 += '<p><span class="bold">'+a+'</span>: '+dt.err_connections_list[a]+'</p>';

						for(let a in dt.note_list)
							_s1 += '<p>'+dt.note_list[a]+'</p>';						
					
						let _html = '';
						_html += '<div><div class="c-red">Błędy połączeń <span class="f-min">(_err_connections_list)</span>:</div><div class="mgl-10 f-min">'+_s1+'</div></div>';
						_html += '<div class="mgt-5"><div class="c-green">Kontener wiadomości <span class="f-min">(_note_list)</span>:</div><div class="mgl-10 f-min">'+_s2+'</div></div>';
						$('#importants_list_disp').html(_html);
					});
					setTimeout(() => {_f();}, 2000);
				}				
				_f();
			}
		});

		function developerChVersionApp(v){
			let ver = prompt('Wersja:', v);
			if(ver !== null && ver.length > 2)
				location.href = 'index.php?a=adv&b=ch_version&c=' + ver;
		}

JAVASCRIPT;

		$s .= '</script>';

		$chvrs = device :: is_develop()? '<span ondblclick="developerChVersionApp(\''.VERSION.'\')">'.VERSION.'</span>' : '<span>'.VERSION.'</span>' ;

		$s_title = '
			<div class="tbl mg-a" style="max-width:250px;">
				<div class="td m"><a href="index.php"><img src="_img/logo_pi.png" alt="" title="" style="max-width:70px;"></a></div>
				<div class="td m"><div class="projectTitle">'.$title.'</div><br><span class="topAppVersion">Wersja aplikacji: '.$chvrs.'</span></div>
			</div>
		';

		$s .= '</head><body>';

		$root = device :: is_develop() ? '<a href="?a=ftp" onclick="return confirm(\'Wykonać?\');"><i class="fa fa-exchange" aria-hidden="true"></i> FTP</a>' : ''  ;		

		$s .= '<header><div class="max_page_width"><div class="tbl full res_b"><div class="td"></div>
		<div class="td c m">'.$s_title.'</div>
		<div class="td sep">&nbsp;</div>
		<div class="td c m top_menu">
			<div class="res_b_s sep_hx _hx1"></div>
			'.$root.'
			<a href="index.php"><i class="fa fa-home" aria-hidden="true"></i> start</a>
			<a href="index.php?a=list_elements"><i class="fa fa-exchange" aria-hidden="true"></i> elementy</a>
			<!--<a href="index.php?a=read&b=print_html"><i class="fa fa-list-ul" aria-hidden="true"></i> wartości</a>-->
			<a href="?a=form_edit"><i class="fa fa-cogs" aria-hidden="true"></i> konfiguracja</a>
			<a href ="?a=devices_detect"><i class="fa fa-search" aria-hidden="true"></i> detekcja urządzeń</a>
			<a href="index.php?a=ric_check" onclick="wait_alert(\'Trwa sprawdzanie\');"><i class="fa fa-check-circle-o" aria-hidden="true"></i> sprawdzenie systemu</a>
			<br>
			<a href="?a=help"><i class="fa fa-question-circle" aria-hidden="true"></i> pomoc</a> 
			<a href="?a=print_spec"><i class="fa fa-print" aria-hidden="true"></i> drukuj zestawienie</a> 
			<a href="index.php?a=update"><i class="fa fa-star-half-o" aria-hidden="true"></i> aktualizacja</a>
			<a href="?a=backup"><i class="fa fa-clone" aria-hidden="true"></i> backup</a>
			<a href="?a=logs_list"><i class="fa fa-server" aria-hidden="true"></i> logi</a>
			<a href="#" onclick="rpih.sendAction(\'reboot\'); return false;"><i class="fa fa-refresh" aria-hidden="true"></i> restart</a>
			<a href ="#" onclick="rpih.sendAction(\'shutdown\'); return false;"><i class="fa fa-power-off" aria-hidden="true"></i> wyłączenie</a>
			<div class="res_b_s sep_hx _hx2"></div>
		</div>
		<div class="td sep">&nbsp;</div>
		<div class="td r center-res"><div data-ihome-logo="100"></div></div>
		</div></div></header>';

		$s .= '
		<section class="und_header">
			<div class="max_page_width">
				<div class="tbl full">
					<div class="td m l nazwa">'.($n? '<h1>'.$n.'</h1>' : '').'</div>
					<div class="td m r submenu">';

			$m = arr :: get($dot_elem, 'menu');
			if(is_array($m) && count($m) > 0)
			{
				foreach($m as $k => $v)
					$s .= '<a href="'.$v.'">'.$k.'</a>';
			}

			$s .= '
					</div>
				</div>
			</div>
		</section>

		';

		$s .= '<script>$(function(){
			$(\'div.top_menu a[href$="'.http::_get('a', 'index.php').'"]\').addClass(\'act\');
		});</script>';

		$s .= '<section class="content"><div class="max_page_width">';

		if(arr :: get($dot_elem, 'disp_importants'))
			$s .= '<div class="right"><div id="importants_list_disp" class="left mgl-a" style="max-width:300px;"></div></div>';		

		return $s;
	}

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	
	public static function footer()
	{
		$s = '';

		$s .= '<div id="panelLockDv"></div>';
		
		$s .= '</div></section>';

		//$s = '<div data-css-set="height,as_div_height,footer">&nbsp;</div>';

		$s .= '<footer><div class="max_page_width">
		<div class="tbl full">
			<div class="td m">Strona projektu: <a href="'.PROJECT_SITE_URL.'" target="_blank" style="color:#aaa;">'.PROJECT_SITE_URL.'</a></div>
			<div class="td r m">Ostatnia aktualizacja: '.(defined('UPDATE_DATE')? UPDATE_DATE : '--brak-danych--').'</div>
		</div>
		</div>
		</footer>';

		return $s . '</div></div></body></html>';
	}

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	public static function msg($msg)
	{
		$s = self :: header();

		$s .= '<div class="center mgt-20 mgb-20">' . $msg . '</div>';

		$s .= self :: footer();

		return $s;
	}

	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	public static function tpl($file, $obj = [])
	{
		if(file_exists($file))
		{
			$s = file_get_contents($file);

			$replaceObj = array(
				'files%' => 'src/files/'
			);

			$s = str_replace(array_keys($replaceObj), array_values($replaceObj), $s);

			$rpl = [];

			foreach($obj as $k => $v)
				$rpl['{$'.$k.'}'] = $v;

			$s = str_replace(array_keys($rpl), array_values($rpl), $s);

			return $s;
		}
		else
			return 'TPL - Nie mozna odnaleźć pliku: '.basename($file).'';
	}

}

?>