import os
import sys
import time
import subprocess
import platform
import json

ROOT_DIR = os.path.abspath(os.path.join(os.path.dirname( __file__ ), '..'))+"/"
sys.path.append(ROOT_DIR + 'pt/')

from _config_top import *
from lib.functions import *

SQL_WORK = msqlLite(SQL_PATH, 'work')

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

class vars_ex:
	def boiler_ot():
		global CONFIG_OBJ, SQL_WORK, FILE_REPOSITORY
		boiler_ot = var_get(CONFIG_OBJ, 'boiler_ot', [])

		_vars = json_file_get_var(FILE_REPOSITORY, 'variables')

		s = ''
		s += 'co='+str(var_get(_vars, var_get(boiler_ot, 'var.co_czy_aktywny', '?'), '0'))
		s += '|cw='+str(var_get(_vars, var_get(boiler_ot, 'var.cwu_czy_aktywny', '?'), '0'))
		s += '|ks='+var_get(boiler_ot, 'kg.s', '')
		s += '|kn=' + var_get(boiler_ot, 'kg.n', '')
		s += '|tc=' + SQL_WORK.getVal('boiler_ot', 'temp_curve', '0')
		s += '|tr=' + var_get(boiler_ot, 'temp.rano', '')
		s += '|td=' + var_get(boiler_ot, 'temp.dzien', '')
		s += '|tw=' + var_get(boiler_ot, 'temp.wieczor', '')
		s += '|tn=' + var_get(boiler_ot, 'temp.noc', '')
		
		[_boiler_ot_temp, _boiler_ot_do_kiedy] = SQL_WORK.getValArr('boiler_ot', 'boost_param', ['0', '00:00'], ';')
		s += '|bt=' + (_boiler_ot_temp + ';' + _boiler_ot_do_kiedy if _boiler_ot_temp != '0' else '')

		return s