import sys
import os
import os.path
import time
import json

ROOT_DIR = os.path.abspath(os.path.join(os.path.dirname( __file__ ), '..'))+"/"
sys.path.append(ROOT_DIR + 'pt/')

from lib.mk_class import *
from lib.outin_class import *
from _config_top import *

if PLATFORM == 'rpi':
	import RPi.GPIO as GPIO
	GPIO.setwarnings(False)
	GPIO.setmode(GPIO.BCM)

SQL_REPLY = msqlLite(SQL_PATH, 'reply')
SQL = msqlLite(SQL_PATH)

RET = {}

_action = str(var_get(sys.argv, 1, ''))

if _action == 'usage':

	RET = sys_info.get_usage()

elif _action == 'modules':

	RET = sys_workingModules.get()

elif _action == 'errors':

	RET = sys_err.get_all()	

elif _action == 'kill_process_nr':

	#call("sleep 3; sudo kill "++" > /dev/null 2>&1 &", shell=True)
	nr = str(var_get(sys.argv, 2, ''))
	RET = call("sudo kill "+ nr) if len(nr)>0 else {'ok':False}

elif _action == 'dops':

	RET = {}#file_create_if_no(ROOT_DIR + 'asdasdasd.txt', str(var_get(sys.argv, 2, '')))

elif _action == 'rs485_data':

	RET = SQL_REPLY.getValues('rs485')

elif _action == 'i2c_data':

	RET = SQL_REPLY.getValues('i2c')	

elif _action == 'rflink_data':

	RET = SQL_REPLY.getValues('rflink')

elif _action == 'zigbee_data':

	RET = SQL_REPLY.getValues('zigbee')

else:

	RET = sys_info.info()

jstr = json.dumps(RET)
print(jstr)