class connErr:
	
	def __init__(self, max_iter = 3):
	
		self.devices = {}
		self._max_i = max_iter	
	
	def addDevice(self, n, desc='', this_max_iter=0):
		if n not in self.devices:
			self.devices[n] = {'desc' : desc if len(desc)>0 else n, 'i' : 0, 'max_iter' : this_max_iter if this_max_iter > 0 else self._max_i}

	def removeDevice(self, n):
		if n in self.devices:
			del self.devices[n]
	
	def setPing(self, n):
		if n in self.devices:
			if self.devices[n]['i'] < self.devices[n]['max_iter']:
				self.devices[n]['i'] += 1

	
	def setReply(self, n):
		if n in self.devices:
			self.devices[n]['i'] = 0

	
	def getErr(self):
		ret = []
		for a in self.devices:
			if self.devices[a]['i'] >= self.devices[a]['max_iter']:
				ret.append(self.devices[a]['desc'])
		return ret